#include "stdafx.h"

#include "CC_Tool.h"
#include "CControlLEDDlg.h"

IMPLEMENT_DYNAMIC(CControlLEDDlg, CDialog)

CControlLEDDlg::CControlLEDDlg(CWnd* pParent /*=nullptr*/)
	: CDialog(IDD_DIALOG_LED, pParent)
{
	pView = (CCC_ToolView*)pParent;
//	m_nState = 0;
	m_nData = 0;
	m_nLimit = 100;

	m_nWave1 = AfxGetApp()->GetProfileInt("LED", "wave1", 400);
	m_nWave2 = AfxGetApp()->GetProfileInt("LED", "wave2", 450);
	m_bMonitor = AfxGetApp()->GetProfileInt("LED", "monitor", 1);
}

CControlLEDDlg::~CControlLEDDlg()
{
	AfxGetApp()->WriteProfileInt("LED", "wave1", m_nWave1);
	AfxGetApp()->WriteProfileInt("LED", "wave2", m_nWave2);
	AfxGetApp()->WriteProfileInt("LED", "monitor", m_bMonitor);
}

void CControlLEDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_GRAPH_TEMP, m_ctlGraph);
	DDX_Control(pDX, IDC_BUTTON_LED_ONOFF, m_ctlOnOff);
	DDX_Control(pDX, IDC_CHECK_MONITOR_SPECTRO, m_ctlMonitor);
	DDX_Control(pDX, IDC_EDIT_MONITOR_WAVE1, m_ctlWave1);
	DDX_Control(pDX, IDC_EDIT_MONITOR_WAVE2, m_ctlWave2);
}


BEGIN_MESSAGE_MAP(CControlLEDDlg, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_LED_ONOFF, &CControlLEDDlg::OnBnClickedButtonLedOnoff)
	ON_BN_CLICKED(IDC_CHECK_MONITOR_SPECTRO, &CControlLEDDlg::OnBnClickedCheckMonitorSpectro)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


void CControlLEDDlg::OnCancel()
{
	// TODO: ɓȃR[hǉ邩A͊NXĂяoĂB
	WINDOWPLACEMENT	wndpl;													// yTCY̕z

	GetWindowPlacement(&wndpl);											// yTCY̕z

	CWinApp* pApp;														// yTCY̕z
	pApp = AfxGetApp();														// yTCY̕z

	pApp->WriteProfileInt("leddlg", "left", wndpl.rcNormalPosition.left);	// yTCY̕z
	pApp->WriteProfileInt("leddlg", "right", wndpl.rcNormalPosition.right);	// yTCY̕z
	pApp->WriteProfileInt("leddlg", "top", wndpl.rcNormalPosition.top);		// yTCY̕z
	pApp->WriteProfileInt("leddlg", "bottom", wndpl.rcNormalPosition.bottom);// yTCY̕z
	DestroyWindow();
//	CDialog::OnCancel();
}


void CControlLEDDlg::PostNcDestroy()
{
	// TODO: ɓȃR[hǉ邩A͊NXĂяoĂB
//	pView->m_hLED = NULL;
	pView->pLED = NULL;
	delete this;
//	CDialog::PostNcDestroy();
}

// f[^C^[o@500ms

#define	DATA_INTERVAL		500

BOOL CControlLEDDlg::OnInitDialog()
{
	CString	str;

	CDialog::OnInitDialog();

	
	str.Format("%d", m_nWave1);	 m_ctlWave1.SetWindowText(str);
	str.Format("%d", m_nWave2);	 m_ctlWave2.SetWindowText(str);
	m_ctlMonitor.SetCheck(m_bMonitor);

	OnBnClickedCheckMonitorSpectro();
	m_nStartTime = GetTickCount() + DATA_INTERVAL;
	SetTimer( 1, DATA_INTERVAL, NULL);

	CWinApp* pApp;												// yTCY̕z
	CRect		rect;												// yTCY̕z

	pApp = AfxGetApp();
	rect.left = pApp->GetProfileInt("leddlg", "left", 0);		// yTCY̕z
	rect.right = pApp->GetProfileInt("leddlg", "right", 650);	// yTCY̕z
	rect.top = pApp->GetProfileInt("leddlg", "top", 0);		// yTCY̕z
	rect.bottom = pApp->GetProfileInt("leddlg", "bottom", 800);	// yTCY̕z
	rect.right = rect.left + 650;
	rect.bottom = rect.top + 800;
	MoveWindow(rect);												// yTCY̕z

	if (pView->m_nLEDState) {
		m_ctlOnOff.SetWindowText("LED ON");
	} else {
		m_ctlOnOff.SetWindowText("LED OFF");
	}
	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


int CControlLEDDlg::DispGraph()
{
	int		i, j;
	float	x, y;
	float	xx, yy;
	float	t;

	CString	str;
	CRect	rect, rect_org;
	CDC* pDC;
	CRect	round;
	CPen* oldPen;
	int		div, rdiv;
	int		n;
	CBitmap* oldbmp;
	CDC		bmpDC;
	CBitmap* cbmp;
	CImage	img;
	float* pData;
	float* pRef;
	CTime	time;

	pDC = m_ctlGraph.GetDC();

	m_ctlGraph.GetClientRect(&rect_org);
	pDC->Rectangle(rect_org);
	rect.left = rect_org.left + 55;
	rect.top = rect_org.top + 45;
	rect.right = rect_org.right - 60;
	rect.bottom = rect_org.bottom - 25;
	pDC->Rectangle(rect);
	m_nLimit = rect.Width()/2;

	time = time.GetCurrentTime();
	str = time.Format("%Y/%m/%d %H:%M:%S");
	pDC->TextOut(rect_org.left + 60, rect_org.top + 22, str);
	pDC->TextOut(rect_org.right - 300, rect_org.top + 2, pView->m_strLED);

	if( m_bMonitor) {

	}
	t = pView->m_dLEDTemp;
	m_dTemp[m_nData] = t;
	m_dWave1[m_nData] = pView->m_dData[0][m_nWave1 - START_WAVE];
	m_dWave2[m_nData] = pView->m_dData[0][m_nWave2 - START_WAVE];
	if ( pView->m_nLEDState) {
		if (m_nData < m_nLimit) {
			m_nData++;
		} else {
			for (i = 0; i < (m_nLimit - 1); i++) {
				m_dTemp[i] = m_dTemp[i + 1];
			}
			m_dTemp[m_nData - 1] = t;
		}
	}
	str.Format("%4.1f", t);
	pDC->TextOut(rect.right -50, rect.top+5, str);

	for (i = 20; i <= 80; i += 5) {
		str.Format("%3d", i);
		y = rect.bottom - (i - 20) * rect.Height() / 60.0;
		pDC->TextOut(rect.left - 30, y - 10, str);
		if ((i > 20) && (i < 80)) {
			oldPen = pDC->SelectObject(pView->m_pLinec[PEN_GRAY][0]);
			pDC->MoveTo(rect.left, y);
			pDC->LineTo(rect.right, y);
			pDC->SelectObject(oldPen);
		}
	}
	for (i = 0; i <=60000; i += 5000) {
		str.Format("%3d", i);
		y = rect.bottom - i  * rect.Height() / 60000;
		pDC->TextOut(rect.right +5, y - 10, str);
	}
	oldPen = pDC->SelectObject(pView->m_pLinec[PEN_GRAY][0]);
	for (i = 0; i < rect.Width()/2; i += 20) {
		x = i * 2;
		if (i > 0) {
			pDC->MoveTo(rect.left + x, rect.top);
			pDC->LineTo(rect.left + x, rect.bottom);
		}
		str.Format("%d", i / 2);
		pDC->TextOut(rect.left + x, rect.bottom + 2, str);
	}
	pDC->SelectObject(oldPen);

	for (i = 0; i < m_nData; i++) {
		x = i * 2+ rect.left;
		y = rect.bottom - (m_dTemp[i] - 20.0) * rect.Height() / 60.0;
		if (y > rect.bottom) y = rect.bottom;
		if (y < rect.top) y = rect.top;
		if (i == 0) {
			pDC->MoveTo(x, y);
		}
		else {
			pDC->LineTo(x, y);
		}
	}
	oldPen = pDC->SelectObject(pView->m_pLinec[PEN_BROWN][0]);
	for (i = 0; i < m_nData; i++) {
		x = i * 2+ rect.left;
		y = rect.bottom - m_dWave1[i] * rect.Height() / 60000;
		if (y > rect.bottom) y = rect.bottom;
		if (y < rect.top) y = rect.top;
		if (i == 0) {
			pDC->MoveTo(x, y);
		}
		else {
			pDC->LineTo(x, y);
		}
	}
	pDC->SelectObject(oldPen);
	oldPen = pDC->SelectObject(pView->m_pLinec[PEN_RED][0]);
	for (i = 0; i < m_nData; i++) {
		x = i * 2+ rect.left;
		y = rect.bottom - m_dWave2[i] * rect.Height() / 60000;
		if (y > rect.bottom) y = rect.bottom;
		if (y < rect.top) y = rect.top;
		if (i == 0) {
			pDC->MoveTo(x, y);
		}
		else {
			pDC->LineTo(x, y);
		}
	}
	pDC->SelectObject(oldPen);
	//	str.Format("%d %d %d", m_nData, x, y);
//	pDC->TextOut(rect.right - 50, rect.top + 25, str);
	ReleaseDC( pDC);

	return 0;
}


void CControlLEDDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1) {
		KillTimer(nIDEvent);
		if (pView->m_nLEDState) {
			m_ctlOnOff.SetWindowText("LED ON");
		}
		else {
			m_ctlOnOff.SetWindowText("LED OFF");
		}
		if (pView->m_nLEDState && (m_nData == 0)) {
			m_nStartTime = GetTickCount();
		}
		DispGraph();
		m_nStartTime += DATA_INTERVAL;

		SetTimer(nIDEvent, m_nStartTime - GetTickCount(), NULL);
	}
	CDialog::OnTimer(nIDEvent);
}


void CControlLEDDlg::OnBnClickedButtonLedOnoff()
{
	CString	str;

	if (pView->m_nLEDState) {
		pView->m_nLEDState = 0;
		m_ctlOnOff.SetWindowText("LED OFF");
		pView->m_ctlLED.SetCheck(0);
	} else {
		pView->m_nLEDState = 1;
		m_nData = 0;
	
		m_ctlWave1.GetWindowText(str);	m_nWave1 = atoi(str);
		m_ctlWave2.GetWindowText(str);	m_nWave2 = atoi(str);
		m_ctlOnOff.SetWindowText("LED ON");
		pView->m_ctlLED.SetCheck(1);
	}
	OnBnClickedCheckMonitorSpectro();
//	pView->SetLED(0, pView->m_nLEDState);
}


void CControlLEDDlg::OnBnClickedCheckMonitorSpectro()
{
//	m_bMonitor = m_ctlMonitor.GetCheck();
//	m_ctlWave1.EnableWindow(m_bMonitor);
//	m_ctlWave2.EnableWindow(m_bMonitor);
	m_ctlWave1.EnableWindow( !pView->m_nLEDState);
	m_ctlWave2.EnableWindow( !pView->m_nLEDState);
}


HBRUSH CControlLEDDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	
	// TODO: lgpȂꍇ͕ʂ̃uVԂ܂B
	return hbr;
}
